#!/usr/bin/python2.4
# -*- coding: utf-8 -*-
from Tkinter import *
##S19
class Pole:
    def __init__(self,x,y,znak):
        self.x=x
        self.y=y
        self.znak=znak
        if znak=='C':
            self.cil=True
            self.volne=True
            self.cesta=True
            self.start=False
            return
        if znak=='X':
            self.cil=False
            self.volne=False
            self.cesta=False
            self.start=False
            return
        if znak=='S':
            self.cil=False
            self.volne=True
            self.cesta=True
            self.start=True
            return
        if znak=='.':
            self.cil=False
            self.volne=True
            self.cesta=False
            self.start=False
            return
        if znak==':':
            self.cil=False
            self.volne=True
            self.cesta=True
            self.start=False
            return
        raise Exception, "Neplatný znak mapy: "+znak+" na X=%d,Y=%d"%(x,y)

def load(filename):
    f=open(filename,'r')
    f=f.read()
    f=(''.join(f.split('\r'))).split('\n')
    f=filter(bool, f)
    if len(f)==0: raise Exception, "Prázdná mapa"
    l=len(f[0])
    if l>255:
        raise Exception, "X velikost mapy víc než 255"
    h=len(f)
    if h>255:
        raise Exception, "Y velikost mapy víc než 255"
    MAPA={}
    for y,v in enumerate(f):
        if len(v)!=l:
            raise Exception, "Délka řádku %d (%d) se neshoduje s délkou řádku 0 (%d)"%(y,len(v),l)
        for x,zn in enumerate(list(f[y])):
            MAPA[(x,y)]=Pole(x=x,y=y,znak=zn)
    return MAPA

def map_xsize(mapa):
    nej_x=0
    for x,y in mapa.keys():
        if x>nej_x:
            nej_x=x
    return nej_x

def map_ysize(mapa):
    nej_y=0
    for x,y in mapa.keys():
        if y>nej_y:
            nej_y=y
    return nej_y

def load_fn(text):
    global LASTFILE
    from FileDialog import LoadFileDialog
    root = Tk()
    root.withdraw()
    fd = LoadFileDialog(root,text)
    
    loadfile = fd.go()
    del fd
    LASTFILE=loadfile
    return loadfile

def load_i():
    return load(load_fn("Vybrat soubor s mapou"))
